Index: trunk/include/compat.h
===================================================================
--- trunk/include/compat.h	(revision 260)
+++ trunk/include/compat.h	(revision 261)
@@ -1,6 +1,4 @@
 /*
- * Copyright (C) 2005-2010 Timothy D. Morgan
- * Copyright (C) 2010 Michael Cohen
- * Copyright (C) 2005 Gerald (Jerry) Carter
+ * Copyright (C) 2010-2011 Timothy D. Morgan
  *
  * This program is free software; you can redistribute it and/or modify
Index: trunk/include/winsec.h
===================================================================
--- trunk/include/winsec.h	(revision 260)
+++ trunk/include/winsec.h	(revision 261)
@@ -1,4 +1,4 @@
 /* 
- * Copyright (C) 2005,2009-2010 Timothy D. Morgan
+ * Copyright (C) 2005,2009-2011 Timothy D. Morgan
  * Copyright (C) 1992-2005 Samba development team 
  * 
Index: trunk/lib/regfi.c
===================================================================
--- trunk/lib/regfi.c	(revision 260)
+++ trunk/lib/regfi.c	(revision 261)
@@ -1,4 +1,4 @@
 /*
- * Copyright (C) 2005-2010 Timothy D. Morgan
+ * Copyright (C) 2005-2011 Timothy D. Morgan
  * Copyright (C) 2005 Gerald (Jerry) Carter
  *
Index: trunk/lib/winsec.c
===================================================================
--- trunk/lib/winsec.c	(revision 260)
+++ trunk/lib/winsec.c	(revision 261)
@@ -1,5 +1,4 @@
 /*
- *
- * Copyright (C) 2005-2006,2009-2010 Timothy D. Morgan
+ * Copyright (C) 2005-2006,2009-2011 Timothy D. Morgan
  * Copyright (C) 1992-2005 Samba development team 
  *               (see individual files under Subversion for details.)
Index: trunk/python/pyregfi/__init__.py
===================================================================
--- trunk/python/pyregfi/__init__.py	(revision 260)
+++ trunk/python/pyregfi/__init__.py	(revision 261)
@@ -1,3 +1,20 @@
 #!/usr/bin/env python
+
+# Copyright (C) 2010-2011 Timothy D. Morgan
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+# $Id: $
 
 ## @package pyregfi
@@ -750,6 +767,5 @@
             # XXX: Native calls to Windows filenos don't seem to work.  
             #      Need to investigate why.
-            #if not is_win32 and hasattr(fh, 'fileno'):
-            if hasattr(fh, 'fileno'):
+            if not is_win32 and hasattr(fh, 'fileno'):
                 fn = fh.fileno()
         except:
Index: trunk/python/pyregfi/structures.py
===================================================================
--- trunk/python/pyregfi/structures.py	(revision 260)
+++ trunk/python/pyregfi/structures.py	(revision 261)
@@ -1,3 +1,20 @@
 #!/usr/bin/env python
+
+# Copyright (C) 2010-2011 Timothy D. Morgan
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+# $Id: $
 
 ## @package pyregfi.structures
Index: trunk/python/pyregfi/winsec.py
===================================================================
--- trunk/python/pyregfi/winsec.py	(revision 260)
+++ trunk/python/pyregfi/winsec.py	(revision 261)
@@ -1,3 +1,20 @@
 #!/usr/bin/env python
+
+# Copyright (C) 2011 Timothy D. Morgan
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 3 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+# $Id: $
 
 ## @package pyregfi.winsec
Index: trunk/src/reglookup.c
===================================================================
--- trunk/src/reglookup.c	(revision 260)
+++ trunk/src/reglookup.c	(revision 261)
@@ -2,5 +2,5 @@
  * A utility to read a Windows NT and later registry files.
  *
- * Copyright (C) 2005-2010 Timothy D. Morgan
+ * Copyright (C) 2005-2011 Timothy D. Morgan
  * Copyright (C) 2010 Tobias Mueller (portions of '-i' code)
  * Copyright (C) 2002 Richard Sharpe, rsharpe@richardsharpe.com